VERSION 5.00
Object = "{79EB16A5-917F-4145-AB5F-D3AEA60612D8}#10.4#0"; "CODEJO~1.OCX"
Begin VB.UserControl ORDatepicker 
   ClientHeight    =   2430
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2505
   ScaleHeight     =   2430
   ScaleWidth      =   2505
   Begin XtremeCalendarControl.DatePicker xdp 
      Height          =   2355
      Left            =   30
      TabIndex        =   0
      Top             =   30
      Width           =   2445
      _Version        =   655364
      _ExtentX        =   4313
      _ExtentY        =   4154
      _StockProps     =   64
      Show3DBorder    =   0
   End
End
Attribute VB_Name = "ORDatepicker"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' ** 26.03.2007 MTB PRIVATE VARIABLES '
Private mStrStartTime As String
Private mStrEndTime As String

' ** 26.03.2007 MTB EVENTS '
Public Event SelectionChanged()

' ** 26.03.2007 MTB PROPERTIES '
Public Property Get EndTime() As String
   EndTime = mStrEndTime
End Property
Public Property Get StartTime() As String
   StartTime = mStrStartTime
End Property

Public Property Let EndTime(ByVal Vvalue As String)
   mStrEndTime = Vvalue
End Property
Public Property Let StartTime(ByVal Vvalue As String)
   mStrStartTime = Vvalue
End Property


Private Sub xdp_SelectionChanged()
   On Error Resume Next
   With xdp
      If (.Selection.BlocksCount = 1) Then
         DateMin = .Selection(0).DateBegin
         DateMax = CStr(.Selection(0).DateEnd)
      ElseIf (.Selection.BlocksCount > 1) Then
         DateMin = .Selection(0).DateBegin
         DateMax = .Selection(.Selection.BlocksCount - 1).DateEnd
      Else
         Debug.Print "SelectionChanged. No Selection"
      End If
   End With
   mStrStartTime = CStr(DateMin)
   mStrEndTime = CStr(DateMax)
   DoEvents
   RaiseEvent SelectionChanged
End Sub

Private Sub UserControl_Initialize()
   With xdp
      .HighlightToday = True
      .ShowWeekNumbers = True
      .TextTodayButton = "Heute"
      .TextNoneButton = "Keine"
      .AutoSize = True
      .Selection.AllowNoncontinuousSelection = False
   End With

End Sub

Private Sub UserControl_Resize()
   On Error Resume Next
With UserControl
   xdp.Move 0, .ScaleTop, .ScaleWidth, .ScaleHeight
End With
End Sub
Public Sub SetSelection(ByVal StartDate As String, ByVal Enddate As String)
   With xdp
      .ClearSelection
      .RedrawControl
      If StartDate <> vbNullString And Enddate <> vbNullString Then
         If IsDate(StartDate) And IsDate(Enddate) Then
            If StartDate <> Enddate Then
               .SelectRange CDate(StartDate), CDate(Enddate)
            Else
               .Select CDate(StartDate)
            End If
         End If
      Else
         If StartDate <> vbNullString And IsDate(StartDate) Then
            .Select CDate(StartDate)
         End If
      End If
      .EnsureVisibleSelection
      .RedrawControl
   End With
End Sub
