VERSION 5.00
Object = "{79EB16A5-917F-4145-AB5F-D3AEA60612D8}#10.4#0"; "CODEJO~1.OCX"
Begin VB.UserControl ORCalendar 
   ClientHeight    =   4245
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   9180
   LockControls    =   -1  'True
   ScaleHeight     =   4245
   ScaleWidth      =   9180
   Begin XtremeCalendarControl.DatePicker wndDatePicker 
      Height          =   4185
      Left            =   30
      TabIndex        =   0
      Top             =   30
      Width           =   2535
      _Version        =   655364
      _ExtentX        =   4471
      _ExtentY        =   7382
      _StockProps     =   64
      Show3DBorder    =   3
      RowCount        =   2
   End
   Begin XtremeCalendarControl.CalendarControl CalendarControl 
      Height          =   4125
      Left            =   2580
      TabIndex        =   1
      Top             =   60
      Width           =   6555
      _Version        =   655364
      _ExtentX        =   11562
      _ExtentY        =   7276
      _StockProps     =   64
   End
   Begin VB.Menu mnuFile 
      Caption         =   "Datei"
      Begin VB.Menu mnuSeparator5 
         Caption         =   "-"
      End
   End
End
Attribute VB_Name = "ORCalendar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

' ##CONTROL VARIABLES '
Private m_pCustomDataHandler  As Object

Private ContextEvent As CalendarEvent

Private ModalFormsRunningCounter As Long

Private DisableDragging_ForRecurrenceEvents As Boolean
Private DisableInPlaceCreateEvents_ForSaSu As Boolean

Private EnableScrollV_DayView As Boolean
Private EnableScrollH_DayView As Boolean

Private EnableScrollV_WeekView As Boolean

Private EnableScrollV_MonthView As Boolean

Private g_DataResourcesMan As New CalendarResourcesManager

Private g_bUseBuiltInCalendarDialogs As Boolean
Private g_dlgCalendarReminders As New CalendarDialogs

' ##PROPERTY VARIABLES '
Private mStrSubject As String
Private mStrLocation As String
Private mStrBody As String
Private mLngLabel As Long
Private mLngShowas As Long
Private mStrStartTime As String
Private mStrEndTime As String
Private nToolTips_Mode As Long
Private mLngEventID As Long

' ##EVENTS '
Public Event AppoinmentEdit()
Public Event ContextMenu(ByVal x As Long, ByVal y As Long)

' ##PROPERTY GETS '
Public Property Get EndTime() As String
   EndTime = mStrEndTime
End Property
Public Property Get StartTime() As String
   StartTime = mStrStartTime
End Property
Public Property Get ShowAs() As Long
   ShowAs = mLngShowas
End Property
Public Property Get Label() As Long
   Label = mLngLabel
End Property
Public Property Get Body() As String
   Body = mStrBody
End Property
Public Property Get Location() As String
   Location = mStrLocation
End Property
Public Property Get Subject() As String
   Subject = mStrSubject
End Property
Public Property Get EventID() As Long
   EventID = mLngEventID
End Property
' ##PROPERTY LETS '

Public Property Let EndTime(ByVal Vvalue As String)
   mStrEndTime = Vvalue
End Property
Public Property Let StartTime(ByVal Vvalue As String)
   mStrStartTime = Vvalue
End Property
Public Property Let ShowAs(ByVal Vvalue As Long)
   mLngShowas = Vvalue
End Property
Public Property Let Label(ByVal Vvalue As Long)
   mLngLabel = Vvalue
End Property
Public Property Let Body(ByVal Vvalue As String)
   mStrBody = Vvalue
End Property
Public Property Let Location(ByVal Vvalue As String)
   mStrLocation = Vvalue
End Property
Public Property Let Subject(ByVal Vvalue As String)
   mStrSubject = Vvalue
End Property
Public Property Let EventID(ByVal Vvalue As Long)
   mLngEventID = Vvalue
End Property
' ##METHODS '

Public Sub SetSize(ByVal width As Long, ByVal height As Long)
   UserControl.height = height
   UserControl.width = width
   UserControl_Resize
End Sub


Public Sub SetViewType(ByVal ViewType As Long)
   On Error Resume Next

   ' Debug.Print "ViewType = " & ViewType '
   Select Case ViewType
      Case 1:
         CalendarControl.ViewType = xtpCalendarDayView
      Case 2:
         CalendarControl.ViewType = xtpCalendarWorkWeekView
      Case 3:
         CalendarControl.ViewType = xtpCalendarMonthView
      Case 4:
         CalendarControl.ViewType = xtpCalendarWeekView
   End Select

End Sub
Public Sub UpdateEvent()
   Dim HitTest As CalendarHitTestInfo
   Dim CalEvent As CalendarEvent
   Dim StartTime As Date
   Dim EndTime As Date
 
   On Error Resume Next

   Set CalEvent = CalendarControl.DataProvider.GetEvent(mLngEventID)
   If Not CalEvent Is Nothing Then
      StartTime = DateFromString(Left(mStrStartTime, 10), Right(mStrStartTime, 8))
      EndTime = DateFromString(Left(mStrEndTime, 10), Right(mStrEndTime, 8))
      OutputDebugString "UpdateEvent Method" & vbCrLf
      OutputDebugString "Subject =" & mStrSubject & vbCrLf
      OutputDebugString "Body  =" & mStrBody & vbCrLf
      OutputDebugString "Label =" & mLngLabel & vbCrLf
      OutputDebugString "BusyStatus =" & mLngShowas & vbCrLf
      OutputDebugString "StartTime =" & StartTime & vbCrLf
      OutputDebugString "EndTime =" & EndTime & vbCrLf
      With CalEvent
         .Subject = mStrSubject
         .Body = mStrBody
         .Label = mLngLabel
         .BusyStatus = mLngShowas
         .StartTime = StartTime
         .EndTime = EndTime
         .Location = mStrLocation
      End With
      CalendarControl.DataProvider.ChangeEvent CalEvent
      CalendarControl.Populate
   Else
      OutputDebugString "CalEvent Is Nothing" & vbCrLf
   End If

End Sub

Private Sub CalendarControl_ContextMenu(ByVal x As Single, ByVal y As Single)
   RaiseEvent ContextMenu(CLng(x), CLng(y))
End Sub

Private Sub CalendarControl_DblClick()
   Dim HitTest As CalendarHitTestInfo
   Dim CalEvent As CalendarEvent
    On Error Resume Next
   ' DoEvents '
   Set HitTest = CalendarControl.ActiveView.HitTest
   Dim Events As CalendarEvents
   If Not HitTest.HitCode = xtpCalendarHitTestUnknown Then
   ' Set Events = CalendarControl.DataProvider.RetrieveDayEvents(HitTest.ViewDay.Date) '
   End If

   If Not HitTest.ViewEvent Is Nothing Then
      Set CalEvent = HitTest.ViewEvent.Event
      With CalEvent
         mStrSubject = .Subject
         mStrBody = .Body
         mLngLabel = .Label
         mLngShowas = .BusyStatus
         mStrStartTime = CStr(.StartTime)
         mStrEndTime = CStr(.EndTime)
         mStrLocation = .Location
         mLngEventID = .Id
      End With

      RaiseEvent AppoinmentEdit
     
   End If

End Sub

' Private Sub CalendarControl_SelectionChanged(ByVal SelType As XtremeCalendarControl.CalendarSelectionChanged)                 '
' If SelType = xtpCalendarSelectionDays Then                                                                                    '
' If CalendarControl.ActiveView.Selection.IsValid Then                                                                          '
' RaiseEvent SelectionChanged(CStr(CalendarControl.ActiveView.Selection.Begin), CStr(CalendarControl.ActiveView.Selection.End)) '
' End If                                                                                                                        '
' End If                                                                                                                        '
' 'If SelType = xtpCalendarSelectionEvents Then                                                                                 '
' '    Debug.Print "SelectionChanged. Event(s)."                                                                                '
' 'End If                                                                                                                       '
' End Sub                                                                                                                       '

Private Sub UserControl_Initialize()
   Dim Today As Date
   Today = Now
   With CalendarControl
      .ViewType = xtpCalendarDayView
      .DayView.ShowDays Today - 2, Today + 2
      .Options.EnableInPlaceEditEventSubject_ByMouseClick = False
  
   End With
   With wndDatePicker
      .ShowWeekNumbers = True
      .AttachToCalendar CalendarControl
      .TextNoneButton = "keine"
      .TextTodayButton = "heute"
   End With

   CalendarGlobalSettings.License = "Calendar Control Copyright (c) " & _
           "2003-2006 Codejock Software" & vbCrLf & "PRODUCT-ID: " & _
           "Codejock.Calendarcontrol.ActiveX.v10.40" & vbCrLf & _
           "VALIDATE-CODE: XXX-XXX-XXX-XXX"
   
   

End Sub

Private Sub UserControl_Resize()
   Dim nHeight As Long, LabelWidth As Long

   On Error Resume Next

   nHeight = UserControl.height - CalendarControl.Top - 12 * Screen.TwipsPerPixelY
   LabelWidth = UserControl.width - 100
   If nHeight < 0 Then
      height = 0
   End If
   If LabelWidth < 0 Then
      LabelWidth = 0
   End If
   With wndDatePicker
      .Top = UserControl.ScaleTop
      .height = nHeight
      CalendarControl.Move .Left + .width, UserControl.ScaleTop, UserControl.width - .width - 12 * Screen.TwipsPerPixelY, nHeight
   End With
End Sub
Public Sub NewEvent(ByVal Subject As String, ByVal Location As String, ByVal Body As String, ByVal Label As Long, ByVal ShowAs As Long)
   Dim m_pEditingEvent As CalendarEvent
   Dim BeginSelection As Date
   Dim EndSelection As Date
   Dim Allday As Boolean

   Set m_pEditingEvent = CalendarControl.DataProvider.CreateEvent

   CalendarControl.ActiveView.GetSelection BeginSelection, EndSelection, Allday

   With m_pEditingEvent
      .StartTime = BeginSelection
      .EndTime = EndSelection
      .Body = Body
      .Label = Label
      .Location = Location
      .Subject = Subject
      .BusyStatus = ShowAs
   End With

   CalendarControl.DataProvider.AddEvent m_pEditingEvent


End Sub


Public Sub ApplyTheme()
   Dim objThemeOfice2007 As CalendarThemeOffice2007
   Dim objDPTheme2007 As New DatePickerThemeOffice2007

   Set objThemeOfice2007 = CalendarControl.Theme

   If objThemeOfice2007 Is Nothing Then
      ' Create and set Theme '
      Set objThemeOfice2007 = New CalendarThemeOffice2007
      CalendarControl.SetTheme objThemeOfice2007
      ' Load customized theme options '
      Dim px As PropExchange
      Set px = XtremeCalendarControl.CreatePropExchange
      If px.CreateAsXML(True, "CalendarThemeOffice2007") Then
         If px.LoadFromFile(App.Path & "\cfgCalendarThemeOffice2007.xml") Then
            CalendarControl.Theme.DoPropExchange px
         End If
      End If
      ' Set theme for DatePicker '
      wndDatePicker.SetTheme objDPTheme2007
   Else
      
      CalendarControl.SetTheme Nothing
      wndDatePicker.SetTheme Nothing
   End If

   CalendarControl.Populate
   wndDatePicker.RedrawControl

End Sub

Public Sub GetCalendarSelection(ByRef StartDate As String, ByRef Enddate As String, Optional ByRef Allday As Long)
   Dim BeginSelection As Date
   Dim EndSelection As Date
   Dim AllDayLong As Boolean
   On Error Resume Next
   CalendarControl.ActiveView.GetSelection BeginSelection, EndSelection, AllDayLong
   StartDate = CStr(BeginSelection)
   Enddate = CStr(EndSelection)
   If AllDayLong = True Then
      Allday = 1
   Else
      Allday = 0
   End If
End Sub
Public Sub PrintPreview()
   CalendarControl.PrintPreviewOptions.Title = "Calendar Control Openroad Sample application"
   CalendarControl.PrintPreview True
End Sub
